/*
This file is part of the NppCrypt Plugin [www.cerberus-design.de] for Notepad++ [ Copyright (C)2003 Don HO <don.h@free.fr> ]

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

#ifndef MDEF_DEFINE_H
#define MDEF_DEFINE_H

#define		NPPC_NAME					"NppCrypt"
#define		NPPC_VERSION				1013

#define		NPPC_FUNC_COUNT				9
#define		NPPC_FUNC_HASH_ID			2
#define		NPPC_FUNC_RANDOM_ID			3
#define		NPPC_FUNC_CONVERT_ID		4

#define		NPPC_ABOUT_TEXT				"nppcrypt v1.0.1.3"
#define		NPPC_ABOUT_LINK				"www.cerberus-design.de/nppcrypt/readme"
#define		NPPC_ABOUT_URL				"http://www.cerberus-design.de/nppcrypt/readme.txt"

#define		NPPC_PREFFILE_HEADER		"nppcrypt.config.v1012"
#define		NPPC_PREFFILE_HEADER_1010	"nppcrypt.config.v1010"
#define		NPPC_PREFFILE_HEADER_LEN	21

#define		NPPC_DEF_HMAC_KEY			"bJmX/AokoOlC}my."
#define		NPPC_DEF_HMAC_LABEL			"nppcrypt default"

#define		NPPC_HMAC_MAX_KEYS			20
#define		NPPC_HMAC_INPUT_MAX			256

#define		NPPC_MAX_LINE_LENGTH		9999

#define		NPPC_DEF_FILE_EXT			"nppcrypt"
#define		NPPC_FILE_EXT_MAXLENGTH		32

#define		NPPC_CRYPT_HMAC_HELP_URL	"https://en.wikipedia.org/wiki/Hash-based_message_authentication_code"
#define		NPPC_CRYPT_IV_HELP_URL		"https://en.wikipedia.org/wiki/Initialization_vector"
#define		NPPC_CRYPT_SALT_HELP_URL	"https://en.wikipedia.org/wiki/Salt_%28cryptography%29"
#define		NPPC_PREFERENCES_HELP_URL	"http://www.cerberus-design.de/nppcrypt/readme.txt"

#endif
